#battle.py
#Copyright (C) 2005 Free Software Foundation
#see GPL.txt for license.

#this file controls the window_battle window.

from Tkinter import *
#needed for the buttons.
import ImageTk
import Image

import g
import main
import action
import monster

mon_index = 0

#mon_hp = StringVar()
hp = StringVar()
ep = StringVar()
monstername = StringVar()
monsterattack = StringVar()
monsterdefense = StringVar()


help_text = StringVar()
return_from_dialog = StringVar()

#location of the various buttons. (Pixels from the left of the button canvas)
attack_button_loc = 0
item_button_loc = 0
skill_button_loc = 0
run_button_loc = 0

#did you run from this battle? Used for scripting.
did_run = 0

#currently selected button. 0=attack, 1=run/leave, 2=use item, 3=use skill
cur_button = 0

#Copy of monster.monster_groups[mon_index].monster_list.
#Used to reduce line length.
monster_list = []

#Number of times you've tried to run from this monster.
#Used to allow better chances after a while.
run_attempts = 0

#x location of the monster hp bar per monster. Used to redraw it.
base_mon_hp_start = []
base_mon_hp_width = []
#y location of the monster hp bar per monster. Used to redraw it.
base_mon_hp_y_start = []
base_mon_hp_height = []

#the currently selected monster.
active_button = -1


#refreshes the battle view. Call after changing anything.
def refresh():
	#hp/ep bars
	for i in range(len(monster_list)):
		canvas_mon_pic.itemconfig(canvas_mon_pic.find_withtag("mon_hp"+str(i)),
			text=str(monster_list[i].hp) + "/" +
			str(monster_list[i].maxhp))

		temp_width = base_mon_hp_width[i]*int(monster_list[i].hp) / \
											int(monster_list[i].maxhp)
		if temp_width < 0: temp_width=0
		canvas_mon_pic.coords(canvas_mon_pic.find_withtag("monster_hp_rect"+str(i)),
				base_mon_hp_start[i],
				base_mon_hp_y_start[i],
				base_mon_hp_start[i] + temp_width,
				base_mon_hp_y_start[i]+5)

	#Draw the monster selection arrow if needed.
	canvas_mon_pic.delete(canvas_mon_pic.find_withtag("monster_arrow"))
	global active_button
	if active_button != -1:
		canvas_mon_pic.create_image(
			base_mon_hp_start[active_button],
			base_mon_hp_y_start[active_button]-20,
			anchor=N, image=g.buttons["sword_pointer.png"], tags="monster_arrow")
	main.recalc_stats(1)

	#clear and rebuild listbox_item
	listbox_item.delete(0, END)
	for i in g.item.inv:
		if i != -1 and (g.item.item[i].type == 11 or g.item.item[i].type == 12):
			listbox_item.insert(END, g.item.item[i].name)

	#clear and rebuild listbox_skill
	listbox_skill.delete(0, END)
	for i in range(len(g.skill)):
		if g.skill[i][5] == 1 and g.skill[i][2] <= g.ep:
			listbox_skill.insert(END, g.skill[i][0] + ": "
				+ str(g.skill[i][2]) + " EP")


#attack button was pressed
def attack(event=0):
	global active_button
	if can_leave() == 1: return 0
	if active_button == -1: last_mon_num = select_monster()
	else: last_mon_num = active_button
	if last_mon_num == -1: return 0
	global cur_button
	cur_button = 0
	clear_slashes()

	#Both hp's *should* be over 0. Just a precaution.
	if monster_list[last_mon_num].hp > 0 and g.hp > 0:
		attack_monster(last_mon_num)
	attack_player()
	if can_leave() == 0:
		active_button = -1
		monster_mouse_move(event)
		refresh()
		refresh_buttons()


#Returns the array location in monster_list of the monster the player wants to
#attack, or -1 on cancel. If more than one monster exists, displays a selection
#arrow.
def select_monster():
	#find out if we need to make the player select a monster.
	num_of_monsters = 0
	last_mon_num = 0
	for i in range(len(monster_list)):
		if monster_list[i].hp > 0:
			num_of_monsters += 1
			last_mon_num = i

	#If there is only one living monster, last_mon_num holds the array location
	#in monster_list[]. Otherwise, ask the player which monster to attack.
	if num_of_monsters == 1: return last_mon_num
	action.has_dialog = 1
	global active_button
	for i in range(len(monster_list)):
		if monster_list[i].hp > 0:
			active_button = i
			break
	else:
		print "BUG: select_monster called when all monsters were dead"
		return -1

	global return_from_dialog
	return_from_dialog.set("0")

	#bindings
	bind_attack_keys()

	refresh()
	#wait. Continue after activate_yesno() is run.
	window_battle.wait_variable(return_from_dialog)
	#cleanup
	if return_from_dialog.get() == "2":
		return -1
	else:
		bind_keys()

		action.has_dialog = 0
		refresh()
		return active_button

#Cycle through the various monsters when attacking. Used by the keyboard.
def choose_monster_prev(event=None):
	global active_button
	i = active_button
	while 1==1:
		i -= 1
		if i == -1:
			i = len(monster_list) - 1
		if monster_list[i].hp > 0:
			active_button = i
			break
		if i == active_button:
			print "choose_monster_prev couldn't find a monster."
			active_button = -1
			return -1
	help_text.set("Attack the " + monster_list[active_button].name)
	set_description_text(active_button)
	refresh()

def choose_monster_next(event=None):
	global active_button
	i = active_button
	while 1==1:
		i += 1
		if i == len(monster_list):
			i = 0
		if monster_list[i].hp > 0:
			active_button = i
			break
		if i == active_button:
			print "choose_monster_next couldn't find a monster."
			active_button = -1
			return -1
	help_text.set("Attack the " + monster_list[active_button].name)
	set_description_text(active_button)
	refresh()

#called on Return when the yesno dialog box is active.
def choose_monster(event=None):
	global return_from_dialog
	return_from_dialog.set("1")

#Cancels the monster selection. Called on Esc.
def cancel_monster(event=None):
	global active_button
	active_button = -1
	global return_from_dialog
	return_from_dialog.set("1")

#Called whenever the mouse moves in the monster canvas. Used to select the
#proper monster, given the x and y location of the mouse.
def monster_mouse_move(event=None):
	try:
		global active_button
		for i in range(len(monster_list)):
			if monster_list[i].hp > 0:
				if event.x >= base_mon_hp_start[i] and \
				event.x <= base_mon_hp_start[i] + base_mon_hp_width[i] and \
				event.y >= base_mon_hp_y_start[i] - base_mon_hp_height[i] and \
				event.y <= base_mon_hp_y_start[i]:
					active_button = i
					help_text.set("Attack the " + monster_list[i].name)
					set_description_text(i)
					refresh()
	except AttributeError:
		active_button = -1

#attack the i'th monster in monster_list[].
def attack_monster(i):
	if i == -1: return
	global cur_mon_hp
	#find the damage done
	damage = g.die_roll(1, g.adj_attack + 2)
	damage = damage - g.die_roll(1, monster_list[i].defense + 2)
	if damage > 0:
 		main.print_message("You hit the " + monster_list[i].name +
 			" for " + str(damage) + " damage.")
		monster_list[i].hp = monster_list[i].hp - damage
		monster_slashed(i)
		#you kill it?
		if monster_list[i].hp <= 0:
			monster_dead(i)
			return 0
	else:
		main.print_message("You miss the " +
				monster_list[i].name + ".")

#Make all monsters attack the player.
def attack_player():
	for i in range(len(monster_list)):
		if monster_list[i].hp > 0 and g.hp > 0:
			attack_player_per_monster(i)


#Make the i'th monster attack you
def attack_player_per_monster(i):
	damage = g.die_roll(1, monster_list[i].attack + 2)
	damage = damage - g.die_roll(1, g.adj_defense + 2)
	if damage > 0:
		main.print_message("The " + monster_list[i].name +
		" hits you for " + str(damage) + " damage.")
		g.hp = g.hp - damage
		monster_slashed("h")
		#you dead yet?
		if g.hp <= 0:
			g.hp = 0
			main.print_message("The " + monster_list[i].name +
			" kills you.")
			cur_button = 1
			refresh()
			refresh_buttons()

	elif monster_list[i].hp > 0:
		main.print_message("The " + monster_list[i].name +
		" misses you.")


#places a slash mark over the i'th monster, to indicate a hit, or "h" for the
#hero.
def monster_slashed(i):
	if len(canvas_mon_pic.find_withtag("hit"+str(i))) == 0:
		if str(i) == "h":
			x, y = canvas_mon_pic.coords(canvas_mon_pic.find_withtag("hero"))
			canvas_mon_pic.create_image(
				x,
				y+g.tiles["people/hero_n.png"].height()/2,
				anchor=CENTER, image=g.buttons["slash_attack.png"], tags="hit"+str(i))
		else:
			canvas_mon_pic.create_image(
				base_mon_hp_start[i]+base_mon_hp_width[i]/2,
				base_mon_hp_y_start[i]-10,
				anchor=S, image=g.buttons["slash_attack.png"], tags="hit"+str(i))

#clears slashmarks for all monsters, and the hero.
def clear_slashes():
	for i in range(len(monster_list)):
		canvas_mon_pic.delete(canvas_mon_pic.find_withtag("hit"+str(i)))
	canvas_mon_pic.delete(canvas_mon_pic.find_withtag("hith"))

#use to reward the player for killing a monster
def monster_dead(i):
	global active_button
	#make the display look better
	monster_list[i].hp = 0
	#add info to listbox_move; add gold and xp
	main.print_message("The " + monster_list[i].name +
	" dies.")

	if len(monster_list[i].on_death) == 0:
		gold = monster_list[i].gold
		g.gold = str(int(g.gold) + gold)
		main.print_message("You find " + str(gold) + " gold,")

		exp = monster_list[i].exp
		main.print_message("and get " + str(exp) + " experience.")
		g.add_exp(exp)
	else:
		action.activate_lines(g.xgrid, g.ygrid, g.zgrid,
					monster_list[i].on_death)

	#finish up
	if can_leave() == 1:
		window_battle.destroy()
		g.cur_window = "main"
		global did_run
		did_run = 0
	else:
		for i in range(len(monster_list)):
			if monster_list[i].hp > 0:
				active_button = i
				break
		refresh()

#returns 1 if battle is finished, (one of the parties is dead) or 0 if not.
def can_leave():
	if g.hp <= 0:
		return 1
	for i in range(len(monster_list)):
		if monster_list[i].hp > 0:
			return 0
	return 1


#run/leave/quit button was pressed
def runaway():
	global run_attempts
	clear_slashes()
	try:
		#leave/quit
		if can_leave() == 1:
			window_battle.destroy()
		#Attempt to run. Testers get better chance.
		else:
			if g.die_roll(1, 10+run_attempts) > 7 or \
					(g.name == "testing123" and g.die_roll(1, 10) > 5):
				window_battle.destroy()
				main.print_message("You coward! You ran away from the "
					+ monster.monster_groups[mon_index].name + ".")
				global did_run
				did_run = 1
			else:
				run_attempts += 1
				main.print_message("You fail to run away.")
				attack_player()
				refresh()
	except TclError:
		pass

#Use item button was pressed
def useitem():
	#don't do anything if battle is over.
	if can_leave() == 1:
		return 0

	clear_slashes()
	#put the name of the item into item_name
	if (len(listbox_item.curselection()) == 0): return 0

	try: item_num = map(int, listbox_item.curselection())
	except ValueError: pass


	item_name = listbox_item.get(item_num[0])


	#find the item[] index and item type
	item_value = g.item.finditem(item_name)
	item_type = g.item.item[item_value].type

	#if item is healing
	if item_type == 11:
		#heal the player, delete the item
		g.hp=g.hp + g.item.item[item_value].quality
		main.print_message("You are healed for " +
					str(g.item.item[item_value].quality) + " health.")
		g.item.drop_inv_item(g.item.find_inv_item(item_value))
		if g.hp >= g.adj_maxhp: g.hp = g.adj_maxhp
		attack_player()

	#if item is explosive
	if item_type == 12:
		sel_mon = select_monster()
		if sel_mon == -1: return 0
		#if monster is still alive
		if monster_list[sel_mon].hp > 0:
			damage = int(g.item.item[item_value].quality)
			g.item.drop_inv_item(g.item.find_inv_item(item_value))
			if damage > 0:
				main.print_message("The " + monster_list[sel_mon].name +
					" is hit for " + str(damage) + " damage.")
				monster_slashed(sel_mon)
			monster_list[sel_mon].hp = monster_list[sel_mon].hp - damage
			#you kill it?
			if monster_list[sel_mon].hp <= 0:
				monster_dead(sel_mon)
			if can_leave() == 0:
				attack_player()
	if can_leave() == 1: return 0
	refresh()

	#replace the cursor
	if (listbox_item.size() != 0):
		listbox_item.selection_set(item_num[0])
		if (len(listbox_item.curselection()) == 0): #last item
			listbox_item.selection_set(END)
			listbox_item.see(END)
		else: listbox_item.see(item_num[0])
	refresh_buttons()


#Use a skill. Called upon hitting the right button; uses the listbox position.
#FIX for multimonster
def useskill():
	#don't do anything if monster is dead.
	if can_leave() == 1:
		return 0

	clear_slashes()
	#get the skill name.
	if (len(listbox_skill.curselection()) == 0): return 0

	try: skill_num = map(int, listbox_skill.curselection())
	except ValueError: pass

	skill_raw_name = listbox_skill.get(skill_num[0])
	skill_array_name = skill_raw_name.split(":", 1)

	#get the skill[] index
	skill_index = g.findskill(skill_array_name[0])

	#make sure we can use that skill, just in case. . .
	if g.skill[skill_index][5] == 0 or g.skill[skill_index][2] > g.ep:
		return 0

	#pay for the skill
	g.ep = int(g.ep) - g.skill[skill_index][2]


	#actually use the skill.
	if g.skill[skill_index][1] == 0: #rage
		main.print_message("You fly into a rage.")
		#increase attack ability
		g.adj_attack += (1 + int(g.level)/4)
		main.attack.set(g.adj_attack)
		attack_player()

	elif g.skill[skill_index][1] == 1: #Sneak away
		global run_attempts
		if g.die_roll(1, 10 + int(g.level) + run_attempts) > 4:
			main.print_message("You coward! You ran away from the " +
				monster.monster_groups[mon_index].name + ".")
			window_battle.destroy()
			global did_run
			did_run = 1
			return 0
		else:
			run_attempts += 3
			main.print_message("You fail to sneak away.")
			attack_player()
	elif g.skill[skill_index][1] == 2: #Frenzy
		mon_num = select_monster()
		for i in range(3 + int(g.level)/3):
			if monster_list[mon_num].hp < 1:
				mon_num = select_monster()
			if mon_num == -1: return 0
			attack_monster(mon_num)
			if can_leave() == 1:
				return 0
			active_button = -1
			monster_mouse_move()
			refresh()
		if can_leave() == 0: attack_player()
	elif g.skill[skill_index][1] == 3: #Dismember
		mon_num = select_monster()
		if mon_num == -1: return 0
		damage = (g.adj_attack * 5)/2
		if damage > 0:
			main.print_message("You hit the " + monster_list[mon_num].name +
				" for " + str(damage) + " damage.")
			monster_slashed(mon_num)
		monster_list[mon_num].hp = monster_list[mon_num].hp - damage
		#you kill it?
		if monster_list[mon_num].hp <= 0:
			monster_dead(mon_num)
		attack_player()

	if can_leave() == 1: return 0
	active_button = -1
	monster_mouse_move()
	refresh()

	#replace the cursor
	if (listbox_skill.size() != 0):
		listbox_skill.selection_set(skill_num[0])
		if (len(listbox_skill.curselection()) == 0): #last skill
			listbox_skill.selection_set(END)
			listbox_skill.see(END)
		else: listbox_skill.see(skill_num[0])
	refresh_buttons()



def refresh_buttons():
	canvas_buttons.delete(ALL)

	if (cur_button == 0):
		canvas_buttons.create_image(attack_button_loc, 0, anchor=NW,
					image=g.buttons["attack_sel.png"])
		help_text.set("Attack the " + monster_list[cur_button].name)
	else: canvas_buttons.create_image(attack_button_loc, 0, anchor=NW,
					image=g.buttons["attack.png"])
	if (cur_button == 1):
		if g.hp <= 0:
			canvas_buttons.create_image(run_button_loc, 0, anchor=NW,
				image=g.buttons["quit_sel.png"])
			help_text.set("Quit")
		elif can_leave() == 0:
			canvas_buttons.create_image(run_button_loc, 0, anchor=NW,
				image=g.buttons["run_sel.png"])
			help_text.set("Run away")
		else:
			canvas_buttons.create_image(run_button_loc, 0, anchor=NW,
				image=g.buttons["leave_sel.png"])
			help_text.set("Leave")
	elif g.hp <= 0: canvas_buttons.create_image(run_button_loc, 0, anchor=NW,
			image=g.buttons["quit.png"])
	elif can_leave == 0:
		canvas_buttons.create_image(run_button_loc,
			0, anchor=NW, image=g.buttons["run.png"])
	else: canvas_buttons.create_image(run_button_loc, 0, anchor=NW,
			image=g.buttons["leave.png"])

	if (cur_button == 2):
		listbox_skill.select_clear(0, END)
		canvas_buttons.create_image(item_button_loc, 0,
			anchor=NW, image=g.buttons["use_sel.png"])
		if (len(listbox_item.curselection()) == 0):
			help_text.set("No items")
		else:
			try: item_num = map(int, listbox_item.curselection())
			except ValueError: pass
			item_name = listbox_item.get(item_num[0])
			help_text.set("Use your " + item_name)
	else: canvas_buttons.create_image(item_button_loc, 0,
			anchor=NW, image=g.buttons["use.png"])

	if (cur_button == 3):
		listbox_item.select_clear(0, END)
		canvas_buttons.create_image(skill_button_loc, 0,
			anchor=NW, image=g.buttons["skill_sel.png"])
		if (len(listbox_skill.curselection()) == 0):
			help_text.set("No useable skills")
		else:
			try: skill_num = map(int, listbox_skill.curselection())
			except ValueError: pass
			skill_name = listbox_skill.get(skill_num[0])
			help_text.set("Use " + skill_name)
	else: canvas_buttons.create_image(skill_button_loc, 0,
			anchor=NW, image=g.buttons["skill.png"])


#All keypresses in window_shop pass through here. Based on the key name,
#give the right action. ("etc", "left", "right", "up", "down", "return")
def key_handler(key_name):
	global cur_button
	if (key_name == "esc"):
		runaway()
		return 0
	elif (key_name == "right"):
		cur_button += 1
		if (cur_button == 1): cur_button = 2 #run is now at end
		elif (cur_button == 2): cur_button = 0 #run is now at end
		if (cur_button == 2): #switch to items
			if (len(listbox_item.curselection()) == 0):
				listbox_item.selection_set(0)
		if (cur_button == 3): #switch to skills
			listbox_item.select_clear(0, END)
			if (len(listbox_skill.curselection()) == 0):
				listbox_skill.selection_set(0)
		if (cur_button == 4): #switch to run
			cur_button = 1
			listbox_skill.select_clear(0, END)
	elif (key_name == "left"):
		cur_button -= 1
		if (cur_button == -1): cur_button = 1 #loop around
		elif (cur_button == 1): cur_button = 0
		elif (cur_button == 0): cur_button = 3
		#if (cur_button == 0): cur_button = 3
		if (cur_button == 0): #switch to attack
		#	cur_button = 0
			listbox_item.select_clear(0, END)
		if (cur_button == 2): #switch to items
			listbox_skill.select_clear(0, END)
			if (len(listbox_item.curselection()) == 0):
				listbox_item.selection_set(0)
		if (cur_button == 3): #switch to skills
			if (len(listbox_skill.curselection()) == 0):
				listbox_skill.selection_set(0)
	elif (key_name == "up"):
		#if (cur_button == 0): cur_button = 1
		#elif (cur_button == 1): cur_button = 0
		if (cur_button == 2):
			try: item_num = map(int, listbox_item.curselection())
			except ValueError: pass
			try:
				if (item_num[0] != 0):
					listbox_item.select_clear(0, END)
					listbox_item.selection_set(item_num[0] - 1)
					listbox_item.see(item_num[0] - 1)
				else:
					listbox_item.select_clear(0, END)
					listbox_item.selection_set(END)
					listbox_item.see(END)
			except IndexError: pass
		if (cur_button == 3):
			try:
				try: skill_num = map(int, listbox_skill.curselection())
				except ValueError: pass
				if (skill_num[0] != 0):
					listbox_skill.select_clear(0, END)
					listbox_skill.selection_set(skill_num[0] - 1)
					listbox_skill.see(skill_num[0] - 1)
				else:
					listbox_skill.select_clear(0, END)
					listbox_skill.selection_set(END)
					listbox_skill.see(END)
			except IndexError: pass

	elif (key_name == "down"):
		#if (cur_button == 0): cur_button = 1
		#elif (cur_button == 1): cur_button = 0
		if (cur_button == 2):
			try: item_num = map(int, listbox_item.curselection())
			except ValueError: pass
			try:
				if (item_num[0] != listbox_item.size() - 1):
					listbox_item.select_clear(0, END)
					listbox_item.selection_set(item_num[0] + 1)
					listbox_item.see(item_num[0] + 1)
				else:
					listbox_item.select_clear(0, END)
					listbox_item.selection_set(0)
					listbox_item.see(0)
			except IndexError: pass
		elif (cur_button == 3):
			try: skill_num = map(int, listbox_skill.curselection())
			except ValueError: pass
			try:
				if (skill_num[0] != listbox_skill.size() - 1):
					listbox_skill.select_clear(0, END)
					listbox_skill.selection_set(skill_num[0] + 1)
					listbox_skill.see(skill_num[0] + 1)
				else:
					listbox_skill.select_clear(0, END)
					listbox_skill.selection_set(0)
					listbox_skill.see(0)
			except IndexError: pass

	elif (key_name == "return"):
		if (cur_button == 0):
			attack()
			return 0
		elif (cur_button == 1):
			runaway()
			return 0
		elif (cur_button == 2):
			useitem()
			return 0
		elif (cur_button == 3):
			useskill()
			return

	refresh_buttons()



def key_handler_esc(event=0): key_handler("esc")
def key_handler_left(event=0): key_handler("left")
def key_handler_right(event=0): key_handler("right")
def key_handler_down(event=0): key_handler("down")
def key_handler_up(event=0): key_handler("up")
def key_handler_return(event=0): key_handler("return")

def mouse_handler_click(event=0):
	mouse_handler_move(event)
	key_handler("return")

def mouse_handler_item(event=0):
	global cur_button; cur_button = 2
	refresh_buttons()

def mouse_handler_skill(event=0):
	global cur_button; cur_button = 3
	refresh_buttons()

def mouse_handler_move(event=0):
	global cur_button
	if (event.x < item_button_loc):
		cur_button = 0
		listbox_item.select_clear(0, END)
		listbox_skill.select_clear(0, END)
	elif (event.x < skill_button_loc):
		cur_button = 2
		listbox_skill.select_clear(0, END)
		if (len(listbox_item.curselection()) == 0):
			listbox_item.selection_set(0)
	elif (event.x < run_button_loc):
		cur_button = 3
		listbox_item.select_clear(0, END)
		if (len(listbox_skill.curselection()) == 0):
			listbox_skill.selection_set(0)
	else:
		cur_button = 1
		listbox_item.select_clear(0, END)
		listbox_skill.select_clear(0, END)
	refresh_buttons()


#Like show_yesno in main, but only expects one or two lines,
#and creates the canvas used.
def battle_show_yesno(line=""):
	action.has_dialog = 1
	global active_button
	active_button = 0
	global return_from_dialog
	return_from_dialog.set("0")

	canvas_width = g.buttons["no.png"].width()*4/3+g.buttons["yes.png"].width()*4/3
	canvas_height = g.buttons["yes.png"].height()+50
	global canvas_battle2
	canvas_battle2 = Canvas(window_battle, width=canvas_width,
		height=canvas_height, highlightthickness=0)
	canvas_battle2.grid(column=1, row=2, columnspan=2, rowspan=7, sticky="S")

	#background
	canvas_battle2.create_rectangle(0, 0, canvas_width, canvas_height,
		fill=g.fill_colour, outline="Black", tags="background_box")
	#text
	canvas_battle2.create_text(3, 3, text=line, anchor="nw",
		width=canvas_width-6, tags="dialogtxt")
	#buttons
	canvas_battle2.create_image(canvas_width/2,
		canvas_height, image=g.buttons["no_sel.png"], anchor="se", tags="no")
	canvas_battle2.create_image(canvas_width/2,
		canvas_height, image=g.buttons["yes.png"], anchor="sw", tags="yes")
	#bindings
	main.window_main.bind(g.binding_up, change_yesno_sel)
	main.window_main.bind(g.binding_right, change_yesno_sel)
	main.window_main.bind(g.binding_left, change_yesno_sel)
	main.window_main.bind(g.binding_down, change_yesno_sel)
	main.window_main.bind(g.binding_action, activate_yesno)
	canvas_battle2.tag_bind("no", "<Enter>", change_yesno_to_no)
	canvas_battle2.tag_bind("yes", "<Enter>", change_yesno_to_yes)
	canvas_battle2.tag_bind("no", "<Button-1>", activate_yesno)
	canvas_battle2.tag_bind("yes", "<Button-1>", activate_yesno)

	canvas_buttons.bind("<ButtonRelease-1>", do_nothing)
	canvas_buttons.bind("<Motion>", do_nothing)
	listbox_item.bind("<ButtonRelease-1>", do_nothing)
	listbox_skill.bind("<ButtonRelease-1>", do_nothing)

	#wait. Continue after activate_yesno() is run.
	window_battle.wait_variable(return_from_dialog)
	#cleanup
	try: canvas_battle2.destroy()
	except TclError: return 1

	bind_keys()

	action.has_dialog = 0
	return active_button


#when a yesno dialog box is active, switch to yes.
def change_yesno_to_yes(event=None):
	global active_button
	active_button = 1
	canvas_battle2.itemconfigure("no", image=g.buttons["no.png"])
	canvas_battle2.itemconfigure("yes", image=g.buttons["yes_sel.png"])

#when a yesno dialog box is active, switch to no.
def change_yesno_to_no(event=None):
	global active_button
	active_button = 0
	canvas_battle2.itemconfigure("no", image=g.buttons["no_sel.png"])
	canvas_battle2.itemconfigure("yes", image=g.buttons["yes.png"])

#when a yesno dialog box is active, switch the yes and no buttons.
def change_yesno_sel(event=None):
	if active_button == 0: change_yesno_to_yes()
	else: change_yesno_to_no()

#called on Return when the yesno dialog box is active.
def activate_yesno(event=None):
	global return_from_dialog
	return_from_dialog.set("1")


#Sets the description to the left of the battle view to that of
#the i'th monster
def set_description_text(i):
	canvas_desc.delete(ALL)
	canvas_desc.create_text(1, 5, anchor=NW,
			text=monster_list[i].description, width=195)
	monstername.set(monster_list[i].name)
	monsterattack.set("Attack: " +
	str(monster_list[i].attack))
	monsterdefense.set("Defense: " +
	str(monster_list[i].defense))

#start a battle.
def begin(mon_index_input):

	global window_battle
	global bgcolour
	bgcolour = "lightgrey"
	window_battle = Frame(main.top, bd=2, relief=SUNKEN, bg=bgcolour)
	window_battle.grid(row=1, column=5, columnspan=13, rowspan=13, sticky=E)
	global mon_index
	mon_index = mon_index_input
	global monster_list
	monster_list = []
	for line in monster.monster_groups[mon_index].monster_list:
		monster_list.append(monster.copy_monster(
				monster.monsters[monster.monster_name_to_index(line)]))
	for i in range(len(monster_list)):
		monster_list[i].reset()

	global did_run
	did_run = 0
	global cur_button
	cur_button = 0
	global run_attempts
	run_attempts = 0
	global active_button
	active_button = -1

	# Set the current window
	g.cur_window = "battle"

	global canvas_desc
	canvas_desc = Canvas(window_battle, width=200, height=190,
		highlightthickness=0, bg=bgcolour)
	canvas_desc.grid(row=2, column=1, sticky=NSEW)

	pic_frame = Frame(window_battle, bd=2, relief=SUNKEN, bg="#327a22")
	pic_frame.grid(row=1, column=2, columnspan=3, rowspan=6, sticky=E)

	global canvas_mon_pic
	background_pic = g.maps[g.zgrid].battle_background
	canvas_mon_pic = Canvas(pic_frame,
		height=background_pic.height(),
		width=background_pic.width())
	canvas_mon_pic.grid(column=2, row=1, rowspan=5, sticky=NW)
	canvas_mon_pic.create_image(0, 0, anchor=NW, image=background_pic)
	monster_pic = []
	global base_mon_hp_start
	base_mon_hp_start = []
	global base_mon_hp_width
	base_mon_hp_width = []
	global base_mon_hp_y_start
	base_mon_hp_y_start = []
	for i in range(len(monster_list)):
		try:monster_pic.append(g.tiles[
							"monsters/" + monster_list[i].name + ".png"])
		except KeyError: monster_pic.append(g.tiles["monsters/generic.png"])

		#if x and y positions were given, use them; otherwise, start at the
		#middle, and go right. This works for 1 or two monsters, but xy
		#coords are recommended for more.
		if len(monster.monster_groups[mon_index].x_pos) > i:
			xstart = monster.monster_groups[mon_index].x_pos[i]
		else: xstart = background_pic.width()/2+i*40
		if len(monster.monster_groups[mon_index].y_pos) > i:
			ystart = monster.monster_groups[mon_index].y_pos[i]
		else: ystart = 10

		canvas_mon_pic.create_image(xstart, ystart,
			anchor=N, image=monster_pic[i])

		base_mon_hp_start.append(xstart - monster_pic[i].width()/2)
		base_mon_hp_width.append(monster_pic[i].width())
		base_mon_hp_height.append(monster_pic[i].height())
		base_mon_hp_y_start.append(ystart + 5+monster_pic[i].height())
		#Under (red) part of the monster hp display
		canvas_mon_pic.create_rectangle(base_mon_hp_start[i], base_mon_hp_y_start[i],
				base_mon_hp_start[i]+base_mon_hp_width[i],
				base_mon_hp_y_start[i]+5, fill="#EE0505")
		#Over (green) part of the monster hp display
		canvas_mon_pic.create_rectangle(base_mon_hp_start[i], base_mon_hp_y_start[i],
				base_mon_hp_start[i]+base_mon_hp_width[i],
				base_mon_hp_y_start[i]+5, fill="#05BB05",
				tags="monster_hp_rect"+ str(i))
		canvas_mon_pic.create_text(xstart,
			base_mon_hp_y_start[i]+7, anchor=N, text="", tags="mon_hp"+str(i))

	try: hero_pic = g.tiles["people/hero_n.png"]
	except KeyError: hero_pic = ImageTk.PhotoImage("RGB", (32, 32))
	canvas_mon_pic.create_image(
				background_pic.width()/2,
				background_pic.height()-hero_pic.height()-5,
				anchor=N, image=hero_pic, tags="hero")


	#formatting for the labels.
	label_formatting = Label(window_battle,
			textvariable=monstername, bg=bgcolour).grid(row=1,
			column=1, columnspan=2)


	label_attack = Label(window_battle, textvariable=monsterattack,
			 bg=bgcolour).grid(row=4, column=1, sticky=W)
	label_defend = Label(window_battle, textvariable=monsterdefense,
			bg=bgcolour).grid(row=4, column=1, sticky=E)

	#help text
	label_text = Label(window_battle,
		textvariable=help_text, bg=bgcolour)
	label_text.grid(column=1, row=5, columnspan=2)
	window_battle.update_idletasks()
	window_battle.columnconfigure(1, minsize=canvas_mon_pic.winfo_width())


	button_frame = Frame(window_battle, bg=bgcolour)
	button_frame.grid(row=14, column=1, columnspan=2, sticky="NSEW")


	global item_button_loc
	global skill_button_loc
	global run_button_loc
	item_button_loc = g.buttons["attack.png"].width()
	skill_button_loc = item_button_loc + g.buttons["use.png"].width()
	run_button_loc = skill_button_loc + g.buttons["skill.png"].width()

	global canvas_buttons
	canvas_buttons = Canvas(button_frame, bg="#b3b3b3",
		height=g.buttons["attack.png"].height(),
		width=run_button_loc + g.buttons["run.png"].width())
	canvas_buttons.grid(column=1, row=1, sticky="NSEW")

	#use item listbox
	item_label = Label(window_battle, text='Items', bg=bgcolour)
	item_label.grid(row=9, column=1, sticky=N)

	global listbox_item
	listbox_item = Listbox(window_battle, height=5, bg=bgcolour)
	listbox_item.grid(row=9, column=1, rowspan=5, sticky=N+S+E+W)
	global item_scroll
	item_scroll = Scrollbar(window_battle, command=listbox_item.yview,
		bg=bgcolour)
	item_scroll.grid(row=9, column=1, rowspan=5, sticky=N+S+E)
	listbox_item.config(yscrollcommand=item_scroll.set)


	skill_label = Label(window_battle, text='Skills', bg=bgcolour)
	skill_label.grid(row=9, column=2, sticky=N)

	global listbox_skill
	listbox_skill = Listbox(window_battle, height=5, bg=bgcolour)
	listbox_skill.grid(row=9, column=2, rowspan=5, sticky="NSEW")
	global skill_scroll
	skill_scroll = Scrollbar(window_battle, command=listbox_skill.yview,
		bg=bgcolour)
	skill_scroll.grid(row=9, column=2, rowspan=5, sticky=N+S+E)
	listbox_skill.config(yscrollcommand=skill_scroll.set)
	window_battle.update_idletasks()
	window_battle.columnconfigure(2, minsize=pic_frame.winfo_width())


	#bindings
	bind_keys()

	main.print_message(monster.monster_groups[mon_index].attack_message)
	set_description_text(0)

	refresh()
	refresh_buttons()

	#keep the window_main window asleep until this one is closed.
	window_battle.master.wait_window(window_battle)
	return did_run


#bind the keys. Called upon window creation and return from a yes/no box
def bind_keys():
	main.window_main.bind(g.binding_attack, attack)
	main.window_main.bind(g.binding_cancel, key_handler_esc)
	main.window_main.bind(g.binding_action, key_handler_return)
	main.window_main.bind(g.binding_up, key_handler_up)
	main.window_main.bind(g.binding_down, key_handler_down)
	main.window_main.bind(g.binding_left, key_handler_left)
	main.window_main.bind(g.binding_right, key_handler_right)
	main.window_main.bind(g.binding_inv, key_handler)
	main.window_main.bind(g.binding_save, key_handler)
	main.window_main.bind(g.binding_quit, key_handler)

	canvas_buttons.bind("<ButtonRelease-1>", mouse_handler_click)
	canvas_buttons.bind("<Motion>", mouse_handler_move)
	listbox_item.bind("<ButtonRelease-1>", mouse_handler_item)
	listbox_skill.bind("<ButtonRelease-1>", mouse_handler_skill)
	canvas_mon_pic.bind("<ButtonRelease-1>", attack)
	canvas_mon_pic.bind("<Motion>", monster_mouse_move)

#keybindings when choosing a monster to attack.
def bind_attack_keys():
	main.window_main.bind(g.binding_attack, choose_monster)
	main.window_main.bind(g.binding_cancel, cancel_monster)
	main.window_main.bind(g.binding_action, choose_monster)
	main.window_main.bind(g.binding_up, choose_monster_prev)
	main.window_main.bind(g.binding_down, choose_monster_next)
	main.window_main.bind(g.binding_left, choose_monster_prev)
	main.window_main.bind(g.binding_right, choose_monster_next)
	main.window_main.bind(g.binding_inv, key_handler)
	main.window_main.bind(g.binding_save, key_handler)
	main.window_main.bind(g.binding_quit, key_handler)

	canvas_buttons.bind("<ButtonRelease-1>", do_nothing)
	canvas_buttons.bind("<Motion>", do_nothing)
	listbox_item.bind("<ButtonRelease-1>", do_nothing)
	listbox_skill.bind("<ButtonRelease-1>", do_nothing)
	canvas_mon_pic.bind("<Motion>", monster_mouse_move)
	canvas_mon_pic.bind("<ButtonRelease-1>", choose_monster)
def do_nothing(event=0):
	pass
